Unit GraphApp;
Interface
Uses
  Crt,Graph,Tarakan,Tools;
Type
  TGraphApp = Object
    T1,T2,T3,T4,T5: TTarakan;
    Procedure Init;
    Procedure Run;
    Destructor Done;
  End;
Implementation

{Procedure Init}
Procedure TGraphApp.Init;
Var
  D,R,Err: Integer;
Begin
  D:=9;
  R:=2;
  InitGraph(D,R,'');
  Err:=GraphResult;
  If Err<>0 Then
    Begin
      GraphErrorMsg(Err);
      Halt(0);
    End;
End;

{Procedure Run}
Procedure TGraphApp.Run;
Label NewGame,Start;
Var
  Stop: Boolean;
  Key: Char;
  i,SRoach,WRoach,Stake,Money: Byte;
  max: Integer;
  t: Array[1..5] Of Integer;
{Begin Procedure Tools}
Procedure ClearZone;
Begin
  SetViewPort(16,340,623,463,True);
  ClearViewPort;
  SetViewPort(0,0,639,479,False);
End;
Procedure WriteMoney;
Begin
  SetViewPort(200,100,500,115,True);
  ClearViewPort;
  SetViewPort(0,0,639,479,False);
  SetTextStyle(DefaultFont, HorizDir, 2);
  SetColor(Green); OutTextXY(200,100,'Your Money: '+IntToStr(Money)+'$');
  SetTextStyle(DefaultFont, HorizDir, 1);
End;
{End Procedure Tools}
Begin
NewGame:
  {Logo;}
  Randomize;
  Money:=100;
Start:
  ClearDevice;
  {Line(319,0,319,479);}
  SetColor(White);
  Rectangle(10,10,629,469); Rectangle(15,339,624,464);
  SetTextStyle(DefaultFont, HorizDir, 3);
  OutTextXY(237,50,'TARAKAN');
  SetTextStyle(DefaultFont, HorizDir, 1);
  Rectangle(15,100,85,130); OutTextXY(30,110,'START');
  Rectangle(554,100,624,130); OutTextXY(564,110,'FINISH');
  SetColor(7);
  Rectangle(55,159,584,189);{OutTextXY(30,169,'1');}
  Rectangle(55,189,584,219);{OutTextXY(30,199,'2');}
  Rectangle(55,219,584,249);{OutTextXY(30,229,'3');}
  Rectangle(55,249,584,279);{OutTextXY(30,259,'4');}
  Rectangle(55,279,584,309);{OutTextXY(30,289,'5');}
  Line(105,159,105,309); Line(534,159,534,309);
  T1.Init(75,174,1); T2.Init(75,204,2);
  T3.Init(75,234,3); T4.Init(75,264,4);
  T5.Init(75,294,5);
  T1.Show; T2.Show; T3.Show; T4.Show; T5.Show;
  SetTextStyle(DefaultFont, HorizDir, 2);
  OutTextXY(30,350,'STAKE'); OutTextXY(135,350,'COCKROACH');
  OutTextXY(310,350,'HELP');
  SetTextStyle(DefaultFont, HorizDir, 1);
  OutTextXY(30,375,'"1" - 10$'); OutTextXY(30,385,'"2" - 20$');
  OutTextXY(30,395,'"3" - 30$'); OutTextXY(30,405,'"4" - 40$');
  OutTextXY(30,415,'"5" - 50$');
  SetColor(9); OutTextXY(135,375,'"B" - Blue');
  SetColor(10); OutTextXY(135,385,'"G" - Green');
  SetColor(11); OutTextXY(135,395,'"C" - Cyan');
  SetColor(12); OutTextXY(135,405,'"R" - Red');
  SetColor(13); OutTextXY(135,415,'"M" - Magenta');
  SetColor(7);
  OutTextXY(310,375,'Select Stake and Cockroach:');
  OutTextXY(310,385,'Press "Stake Key" and "Cockroach Key".');
  OutTextXY(310,405,'Example: "3" and "R"');
  OutTextXY(310,415,'(The Stake 30$ on a Red Cockroach).');
  WriteMoney;
  SetColor(Yellow);
  OutTextXY(160,450,'Press "Stake Key" and "Cockroach Key"...');
  SetColor(White);
  Repeat
    Stake:=0;
    CleanBufferKeyboard;
    Key:=ReadKey;
    If (Key=#49) And (Money>9) Then
      Begin
        Stake:=10;
        OutTextXY(190,120,'The Stake 10$ on a');
      End;
    If (Key=#50) And (Money>19) Then
      Begin
        Stake:=20;
        OutTextXY(190,120,'The Stake 20$ on a');
      End;
    If (Key=#51) And (Money>29) Then
      Begin
        Stake:=30;
        OutTextXY(190,120,'The Stake 30$ on a');
      End;
    If (Key=#52) And (Money>39) Then
      Begin
        Stake:=40;
        OutTextXY(190,120,'The Stake 40$ on a');
      End;
    If (Key=#53) And (Money>49) Then
      Begin
        Stake:=50;
        OutTextXY(190,120,'The Stake 50$ on a');
      End;
  Until (Stake=10)Or(Stake=20)Or(Stake=30)Or(Stake=40)Or(Stake=50);
  Money:=Money-Stake;
  WriteMoney;
  Repeat
    SRoach:=0;
    CleanBufferKeyboard;
    Key:=ReadKey;
    If (Key=#66) Or (Key=#98) Then
      Begin
        SRoach:=1;
        SetColor(9);
        OutTextXY(340,120,'Blue Cockroach');
      End;
    If (Key=#71) Or (Key=#103) Then
      Begin
        SRoach:=2;
        SetColor(10);
        OutTextXY(340,120,'Green Cockroach');
      End;
    If (Key=#67) Or (Key=#99) Then
      Begin
        SRoach:=3;
        SetColor(11);
        OutTextXY(340,120,'Cyan Cockroach');
      End;
    If (Key=#82) Or (Key=#114) Then
      Begin
        SRoach:=4;
        SetColor(12);
        OutTextXY(340,120,'Red Cockroach');
      End;
    If (Key=#77) Or (Key=#109) Then
      Begin
        SRoach:=5;
        SetColor(13);
        OutTextXY(340,120,'Magenta Cockroach');
      End;
  Until (SRoach=1) Or (SRoach=2) Or (SRoach=3) Or (SRoach=4) Or (SRoach=5);
  SetViewPort(16,440,623,463,True);
  ClearViewPort;
  SetViewPort(0,0,639,479,False);
  SetColor(Yellow); OutTextXY(240,450,'Press Enter to START');
  Repeat
    CleanBufferKeyboard;
  Until ReadKey=#13;
  ClearZone;
  SetColor(White);
  SetTextStyle(DefaultFont, HorizDir, 2);
  OutTextXY(215,390,'PLEASE WAIT...');
  SetTextStyle(DefaultFont, HorizDir, 1);
  Stop:=False;
  Repeat
    SetColor(7);
    Line(105,159,105,309); Line(534,159,534,309);
    T1.MoveTo(Random(2)); T2.MoveTo(Random(2));
    T3.MoveTo(Random(2)); T4.MoveTo(Random(2));
    T5.MoveTo(Random(2));
    Delay(100);
    If (T1.GetX>552) Or (T2.GetX>552) Or (T3.GetX>552)
      Or (T4.GetX>552) Or (T5.GetX>552) Then Stop:=True;
  Until Stop=True;
  t[1]:=T1.GetX; t[2]:=T2.GetX; t[3]:=T3.GetX; t[4]:=T4.GetX; t[5]:=T5.GetX;
  max:=t[1];
  For i:=1 To 5 Do
    Begin
      If (max<t[i]) Then max:=t[i];
    End;
  SetTextStyle(DefaultFont, HorizDir, 3);
  If (max=T1.GetX) Then
    Begin
      WRoach:=1;
      ClearZone;
      SetColor(1); OutTextXY(224,390,'BLUE WIN');
    End;
  If (max=T2.GetX) Then
    Begin
      WRoach:=2;
      ClearZone;
      SetColor(2); OutTextXY(212,390,'GREEN WIN');
    End;
  If (max=T3.GetX) Then
    Begin
      WRoach:=3;
      ClearZone;
      SetColor(3); OutTextXY(224,390,'CYAN WIN');
    End;
  If (max=T4.GetX) Then
    Begin
      WRoach:=4;
      ClearZone;
      SetColor(4); OutTextXY(237,390,'RED WIN');
    End;
  If (max=T5.GetX) Then
    Begin
      WRoach:=5;
      ClearZone;
      SetColor(5); OutTextXY(192,390,'MAGENTA WIN');
    End;
  SetColor(White);
  If (SRoach=WRoach) Then
    Begin
      OutTextXY(35,350,'You win in this running!');
      Money:=Money+(Stake*2);
    End
  Else OutTextXY(24,350,'You lost in this running!');
  WriteMoney;
  If (Money<1) Then
    Begin
      Delay(65535);
      ClearDevice;
      SetTextStyle(DefaultFont, HorizDir, 8);
      SetColor(LightRed); OutTextXY(40,200,'Game Over');
    End;
  If (Money>199) Then
    Begin
      Delay(65535);
      ClearDevice;
      SetTextStyle(DefaultFont, HorizDir, 8);
      SetColor(LightGreen); OutTextXY(100,200,'You Win');
    End;
  SetTextStyle(DefaultFont, HorizDir, 1);
  SetColor(Yellow); OutTextXY(195,450,'Press R to REPLAY or Esc to EXIT');
  Stop:=False;
  Repeat
    CleanBufferKeyboard;
    Key:=ReadKey;
    If (Key=#82) Or (Key=#114) Then
       Begin
         If (Money<1) Or (Money>199) Then GoTo NewGame Else GoTo Start;
       End;
    If (Key=#27) Then Stop:=True;
  Until Stop=True;
End;

{Destructor Done}
Destructor TGraphApp.Done;
Begin
  CloseGraph;
End;
END.