Unit Tarakan;
Interface
Type
  TTarakan = Object
    X,Y: Integer;
    Color: Byte;
    Constructor Init(aX,aY: Integer; aColor: Byte);
    Procedure Draw(aColor: Byte);
    Procedure Show;
    Procedure Hide;
    Procedure MoveTo(dX: Byte);
    Function GetX: Integer;
  End;
Implementation
Uses Graph;
Constructor TTarakan.Init;
Begin
  X:=aX;
  Y:=aY;
  Color:=aColor;
End;
Procedure TTarakan.Draw;
Begin
  SetColor(aColor); SetFillStyle(9,aColor);
  Line(X+20,Y-2,X+25,Y-5); Line(X+20,Y+2,X+25,Y+5);
  Line(X-10,Y-10,X+10,Y+10); Line(X,Y-10,X,Y+10); Line(X+10,Y-10,X-10,Y+10);
  FillEllipse(X,Y,14,7); FillEllipse(X+14,Y,5,5);
  SetColor(White); SetFillStyle(1,White);
End;
Procedure TTarakan.Show;
Begin
  Draw(Color);
End;
Procedure TTarakan.Hide;
Begin
  Draw(GetBkColor);
End;
Procedure TTarakan.MoveTo;
Begin
  Hide;
  X:=X+dX;
  Show;
End;
Function TTarakan.GetX: Integer;
Begin
  GetX:=X;
End;
END.